# Motivace k volání přepsané metody
from proto import obj

# Prototyp popisku 
label = obj.clone().set_name("label")
label.add_slot("text")
label.set_text("")

# Prototyp okna
window = obj.clone().set_name("window")
window.add_slot("widget")

# Prototyp okna s popiskem
labeled_window = window.clone().set_name("labeled_window")
labeled_window.set_widget(label.clone())

# Klon okna s popiskem
labeled_window1 = labeled_window.clone()

# Problém:
"""
>>> labeled_window1.widget().set_text("A")
<label at 0x10a750f50>
>>> labeled_window.widget().text()
'A'
"""

# Jeho zdroj:
"""
>>> labeled_window.widget() is labeled_window1.widget()
True
"""
