# Volání přepsané metody
from proto import obj
from proto_ui import display_object

# Prototyp popisku 
label = obj.clone().set_name("label")
label.add_slot("text")
label.set_text("")

# Prototyp okna
window = obj.clone().set_name("window")
window.add_slot("widget")

# Klonování okna způsobí naklonování jeho obsahu:
def window_clone(resend, self):
    clone = resend() # přeposlání zprávy rodiči vlastníka
    if self.widget():
        clone.set_widget(self.widget().clone())
    return clone

window.set_slot("clone", window_clone)

# Prototyp okna s popiskem
labeled_window = window.clone().set_name("labeled_window")
labeled_window.set_widget(label.clone())

# Klon okna s popiskem
labeled_window1 = labeled_window.clone()

# K problému nedochází:
"""
labeled_window1.widget().set_text("A")
<label at 0x10dc45410>
labeled_window.widget().text()
''
"""
# Zobrazení v ui:
"""
display_object(labeled_window1)
"""

# Klon nesdílí obsah s prototypem:
"""
>>> labeled_window.widget() is labeled_window1.widget()
False
"""
